import math
from vibes import *
from sepinterval import *


class Box:
    def __init__(X,a,b):
        X.x,X.y = a,b
            
    def __repr__(X):
        return "[%f, %f]_[%d,%d] X [%f, %f]_[%d,%d]"%(X.x.lb, X.x.ub,X.x.ca,X.x.cb,X.y.lb, X.y.ub,X.y.ca,X.y.cb)


    def width(X):
        if X.x.is_empty() | X.y.is_empty():
            return -oo
        else:
            return max(X.x.width(),X.y.width())
            
    
    def left(X):
        if X.x.width()>X.y.width():
            return Box(X.x.left(),X.y)
        else:
            return Box(X.x,X.y.left())

    def right(X):
        if X.x.width()>X.y.width(): return Box(X.x.right(),X.y)
        else: return Box(X.x,X.y.right())

    def is_empty(X):
        return X.x.is_empty()|X.y.is_empty()


    def copy(X):
        return Box(X.x,X.y)


def drawDiffBox(X0,X,normal=True):

    if normal:
        ch1="red[magenta]"
        ch0='blue[cyan]'
        if X.is_empty() and X.x.ca==1:
            vibes.drawBox(  X0.x.lb,  X0.x.ub,X0.y.lb, X0.y.ub, ch1)
        if X.is_empty() and X.x.ca==0:
            vibes.drawBox(  X0.x.lb,  X0.x.ub,X0.y.lb, X0.y.ub, ch0)
        if X.x.ca== 0: 
            vibes.drawBox(  X0.x.lb,  X.x.lb,           X0.y.lb, X0.y.ub, ch0)
            X0=Box(Interval( X.x.lb, X0.x.ub), Interval(X0.y.lb, X0.y.ub))
        if X.x.ca== 1: 
            vibes.drawBox(  X0.x.lb,  X.x.lb,           X0.y.lb, X0.y.ub, ch1)
            X0=Box(Interval( X.x.lb, X0.x.ub), Interval(X0.y.lb, X0.y.ub))
        if X.y.ca== 0: 
            vibes.drawBox(  X0.x.lb, X0.x.ub,           X0.y.lb,  X.y.lb, ch0)
            X0=Box(Interval(X0.x.lb, X0.x.ub), Interval( X.y.lb, X0.y.ub))
        if X.y.ca== 1: 
            vibes.drawBox(  X0.x.lb, X0.x.ub,           X0.y.lb,  X.y.lb, ch1)
            X0=Box(Interval(X0.x.lb, X0.x.ub), Interval( X.y.lb, X0.y.ub))
        if X.x.cb== 0: 
            vibes.drawBox(   X.x.ub, X0.x.ub,           X0.y.lb, X0.y.ub, ch0)
            X0=Box(Interval( X0.x.lb, X.x.ub), Interval(X0.y.lb, X0.y.ub))
        if X.x.cb== 1: 
            vibes.drawBox(   X.x.ub, X0.x.ub,           X0.y.lb, X0.y.ub, ch1)
            X0=Box(Interval( X0.x.lb, X.x.ub), Interval(X0.y.lb, X0.y.ub))
        if X.y.cb== 0: 
            vibes.drawBox(  X0.x.lb, X0.x.ub,            X.y.ub, X0.y.ub, ch0)
            X0=Box(Interval(X0.x.lb, X0.x.ub), Interval( X0.y.lb, X.y.ub))
        if X.y.cb== 1: 
            vibes.drawBox(  X0.x.lb, X0.x.ub,            X.y.ub, X0.y.ub, ch1)
        return

    if (X.x.ca==1):
        vibes.drawBox(  X.x.lb, X.x.lb+0.01,X.y.lb, X.y.ub,'red[orange]')
    if (X.x.cb==1):
        vibes.drawBox(  X.x.ub-0.01, X.x.ub,X.y.lb, X.y.ub,'red[orange]')
    if (X.y.ca==1):
        vibes.drawBox(  X.x.lb, X.x.ub,X.y.lb, X.y.lb+0.01,'red[orange]')
    if (X.y.cb==1):
        vibes.drawBox(  X.x.lb, X.x.ub,X.y.ub-0.01, X.y.ub,'red[orange]')
    if (X.x.ca==0):
        vibes.drawBox(  X.x.lb, X.x.lb+0.01,X.y.lb, X.y.ub,'blue[blue]')
    if (X.x.cb==0):
        vibes.drawBox(  X.x.ub-0.01, X.x.ub,X.y.lb, X.y.ub,'blue[blue]')
    if (X.y.ca==0):
        vibes.drawBox(  X.x.lb, X.x.ub,X.y.lb, X.y.lb+0.01,'blue[blue]')
    if (X.y.cb==0):
        vibes.drawBox(  X.x.lb, X.x.ub,X.y.ub-0.01, X.y.ub,'blue[blue]')


if __name__ == '__main__':
    a = Interval(2,4)
    b = Interval(4,8)
    print(a)
    X=Box(a,b)
    print ("X = ",X)
    print ("X.left() = ",X.left())
    print ("X.right() = ",X.right())
    X0=X.copy()
    X.x=Interval(10,11)
    print ("X0 = ",X0)

    

